Index: issm/trunk/src/c/classes/Loads/Numericalflux.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Numericalflux.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Numericalflux.cpp	(revision 18301)
@@ -21,6 +21,5 @@
 
 /*Numericalflux constructors and destructor*/
-/*FUNCTION Numericalflux::Numericalflux(){{{*/
-Numericalflux::Numericalflux(){
+Numericalflux::Numericalflux(){/*{{{*/
 	this->parameters = NULL;
 	this->helement   = NULL;
@@ -31,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::Numericalflux(int id, int i, IoModel* iomodel, int analysis_type) {{{*/
-Numericalflux::Numericalflux(int numericalflux_id,int i,int index,IoModel* iomodel, int in_analysis_type){
+Numericalflux::Numericalflux(int numericalflux_id,int i,int index,IoModel* iomodel, int in_analysis_type){/*{{{*/
 
 	/* Intermediary */
@@ -124,6 +122,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::~Numericalflux(){{{*/
-Numericalflux::~Numericalflux(){
+Numericalflux::~Numericalflux(){/*{{{*/
 	this->parameters=NULL;
 	delete helement;
@@ -134,6 +131,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Numericalflux::Echo {{{*/
-void Numericalflux::Echo(void){
+void Numericalflux::Echo(void){/*{{{*/
 	_printf_("Numericalflux:\n");
 	_printf_("   id: " << id << "\n");
@@ -146,6 +142,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::DeepEcho {{{*/
-void Numericalflux::DeepEcho(void){
+void Numericalflux::DeepEcho(void){/*{{{*/
 
 	_printf_("Numericalflux:\n");
@@ -163,11 +158,9 @@
 }		
 /*}}}*/
-/*FUNCTION Numericalflux::Id {{{*/
-int    Numericalflux::Id(void){
+int Numericalflux::Id(void){/*{{{*/
 	return id;
 }
 /*}}}*/
-/*FUNCTION Numericalflux::ObjectEnum{{{*/
-int Numericalflux::ObjectEnum(void){
+int Numericalflux::ObjectEnum(void){/*{{{*/
 
 	return NumericalfluxEnum;
@@ -175,6 +168,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::copy {{{*/
-Object* Numericalflux::copy() {
+Object* Numericalflux::copy() {/*{{{*/
 
 	Numericalflux* numericalflux=NULL;
@@ -205,6 +197,5 @@
 
 /*Load virtual functions definitions:*/
-/*FUNCTION Numericalflux::Configure {{{*/
-void  Numericalflux::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
+void  Numericalflux::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
 
 	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
@@ -223,11 +214,23 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::SetCurrentConfiguration {{{*/
-void  Numericalflux::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
-
-}
-/*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrix {{{*/
-void  Numericalflux::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){
+void  Numericalflux::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+void  Numericalflux::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->vertices=NULL;
+	this->element=NULL;
+	this->parameters=NULL;
+
+	/*Get Element type*/
+	this->hnodes->reset();
+	this->hvertices->reset();
+	this->helement->reset();
+
+}
+/*}}}*/
+void  Numericalflux::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
 
 	/*recover some parameters*/
@@ -259,6 +262,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVector {{{*/
-void  Numericalflux::CreatePVector(Vector<IssmDouble>* pf){
+void  Numericalflux::CreatePVector(Vector<IssmDouble>* pf){/*{{{*/
 
 	/*recover some parameters*/
@@ -289,6 +291,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::GetNodesSidList{{{*/
-void Numericalflux::GetNodesSidList(int* sidlist){
+void  Numericalflux::GetNodesSidList(int* sidlist){/*{{{*/
 
 	_assert_(sidlist);
@@ -307,6 +308,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::GetNodesLidList{{{*/
-void Numericalflux::GetNodesLidList(int* lidlist){
+void  Numericalflux::GetNodesLidList(int* lidlist){/*{{{*/
 
 	_assert_(lidlist);
@@ -325,6 +325,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::GetNumberOfNodes{{{*/
-int Numericalflux::GetNumberOfNodes(void){
+int   Numericalflux::GetNumberOfNodes(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -339,11 +338,9 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::IsPenalty{{{*/
-bool Numericalflux::IsPenalty(void){
+bool  Numericalflux::IsPenalty(void){/*{{{*/
 	return false;
 }
 /*}}}*/
-/*FUNCTION Numericalflux::PenaltyCreateKMatrix {{{*/
-void  Numericalflux::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){
+void  Numericalflux::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){/*{{{*/
 
 	/*No stiffness loads applied, do nothing: */
@@ -352,6 +349,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::PenaltyCreatePVector{{{*/
-void  Numericalflux::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){
+void  Numericalflux::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){/*{{{*/
 
 	/*No penalty loads applied, do nothing: */
@@ -360,12 +356,10 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::InAnalysis{{{*/
-bool Numericalflux::InAnalysis(int in_analysis_type){
+bool  Numericalflux::InAnalysis(int in_analysis_type){/*{{{*/
 	if (in_analysis_type==this->analysis_type) return true;
 	else return false;
 }
 /*}}}*/
-/*FUNCTION Numericalflux::SetwiseNodeConnectivity{{{*/
-void Numericalflux::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){
+void  Numericalflux::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){/*{{{*/
 
 	/*Output */
@@ -423,6 +417,5 @@
 
 /*Numericalflux management*/
-/*FUNCTION Numericalflux::CreateKMatrixMasstransport{{{*/
-ElementMatrix* Numericalflux::CreateKMatrixMasstransport(void){
+ElementMatrix* Numericalflux::CreateKMatrixMasstransport(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -436,6 +429,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixMasstransportInternal {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixMasstransportInternal(void){
+ElementMatrix* Numericalflux::CreateKMatrixMasstransportInternal(void){/*{{{*/
 
 	/* constants*/
@@ -473,6 +465,6 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentBFlux(&B[0],gauss,index1,index2);
-		tria->GetSegmentBprimeFlux(&Bprime[0],gauss,index1,index2);
+		tria->GetSegmentBFlux(&B[0],gauss,index1,index2,tria->FiniteElement());
+		tria->GetSegmentBprimeFlux(&Bprime[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -501,6 +493,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixMasstransportBoundary {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixMasstransportBoundary(void){
+ElementMatrix* Numericalflux::CreateKMatrixMasstransportBoundary(void){/*{{{*/
 
 	/* constants*/
@@ -552,5 +543,5 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2);
+		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -573,6 +564,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixBalancethickness{{{*/
-ElementMatrix* Numericalflux::CreateKMatrixBalancethickness(void){
+ElementMatrix* Numericalflux::CreateKMatrixBalancethickness(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -586,6 +576,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixBalancethicknessInternal {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixBalancethicknessInternal(void){
+ElementMatrix* Numericalflux::CreateKMatrixBalancethicknessInternal(void){/*{{{*/
 
 	/* constants*/
@@ -622,6 +611,6 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentBFlux(&B[0],gauss,index1,index2);
-		tria->GetSegmentBprimeFlux(&Bprime[0],gauss,index1,index2);
+		tria->GetSegmentBFlux(&B[0],gauss,index1,index2,tria->FiniteElement());
+		tria->GetSegmentBprimeFlux(&Bprime[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -650,6 +639,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixBalancethicknessBoundary {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixBalancethicknessBoundary(void){
+ElementMatrix* Numericalflux::CreateKMatrixBalancethicknessBoundary(void){/*{{{*/
 
 	/* constants*/
@@ -700,5 +688,5 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2);
+		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -721,6 +709,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixAdjointBalancethickness{{{*/
-ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethickness(void){
+ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethickness(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -734,6 +721,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixAdjointBalancethicknessInternal {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethicknessInternal(void){
+ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethicknessInternal(void){/*{{{*/
 
 	ElementMatrix* Ke=CreateKMatrixBalancethicknessInternal();
@@ -742,6 +728,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreateKMatrixAdjointBalancethicknessBoundary {{{*/
-ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethicknessBoundary(void){
+ElementMatrix* Numericalflux::CreateKMatrixAdjointBalancethicknessBoundary(void){/*{{{*/
 
 	ElementMatrix* Ke=CreateKMatrixBalancethicknessBoundary();
@@ -750,6 +735,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorMasstransport{{{*/
-ElementVector* Numericalflux::CreatePVectorMasstransport(void){
+ElementVector* Numericalflux::CreatePVectorMasstransport(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -763,6 +747,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorMasstransportInternal{{{*/
-ElementVector* Numericalflux::CreatePVectorMasstransportInternal(void){
+ElementVector* Numericalflux::CreatePVectorMasstransportInternal(void){/*{{{*/
 
 	/*Nothing added to PVector*/
@@ -771,6 +754,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorMasstransportBoundary{{{*/
-ElementVector* Numericalflux::CreatePVectorMasstransportBoundary(void){
+ElementVector* Numericalflux::CreatePVectorMasstransportBoundary(void){/*{{{*/
 
 	/* constants*/
@@ -822,5 +804,5 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2);
+		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -841,6 +823,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorBalancethickness{{{*/
-ElementVector* Numericalflux::CreatePVectorBalancethickness(void){
+ElementVector* Numericalflux::CreatePVectorBalancethickness(void){/*{{{*/
 
 	switch(this->flux_type){
@@ -854,6 +835,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorBalancethicknessInternal{{{*/
-ElementVector* Numericalflux::CreatePVectorBalancethicknessInternal(void){
+ElementVector* Numericalflux::CreatePVectorBalancethicknessInternal(void){/*{{{*/
 
 	/*Nothing added to PVector*/
@@ -862,6 +842,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorBalancethicknessBoundary{{{*/
-ElementVector* Numericalflux::CreatePVectorBalancethicknessBoundary(void){
+ElementVector* Numericalflux::CreatePVectorBalancethicknessBoundary(void){/*{{{*/
 
 	/* constants*/
@@ -911,5 +890,5 @@
 		gauss->GaussPoint(ig);
 
-		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2);
+		tria->GetSegmentNodalFunctions(&L[0],gauss,index1,index2,tria->FiniteElement());
 
 		vxaverage_input->GetInputValue(&vx,gauss);
@@ -929,6 +908,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::CreatePVectorAdjointBalancethickness{{{*/
-ElementVector* Numericalflux::CreatePVectorAdjointBalancethickness(void){
+ElementVector* Numericalflux::CreatePVectorAdjointBalancethickness(void){/*{{{*/
 
 	/*No PVector for the Adjoint*/
@@ -936,6 +914,5 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::GetNormal {{{*/
-void Numericalflux:: GetNormal(IssmDouble* normal,IssmDouble xyz_list[4][3]){
+void Numericalflux:: GetNormal(IssmDouble* normal,IssmDouble xyz_list[4][3]){/*{{{*/
 
 	/*Build unit outward pointing vector*/
Index: issm/trunk/src/c/classes/Loads/Numericalflux.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Numericalflux.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Numericalflux.h	(revision 18301)
@@ -58,4 +58,5 @@
 		void Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
 		void SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
+		void ResetHooks();
 		void CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs);
 		void CreatePVector(Vector<IssmDouble>* pf);
Index: issm/trunk/src/c/classes/Loads/Pengrid.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Pengrid.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Pengrid.cpp	(revision 18301)
@@ -20,6 +20,5 @@
 
 /*Pengrid constructors and destructor*/
-/*FUNCTION Pengrid::Pengrid(){{{*/
-Pengrid::Pengrid(){
+Pengrid::Pengrid(){/*{{{*/
 	this->parameters=NULL;
 	this->hnode=NULL;
@@ -36,6 +35,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::Pengrid(int index, int id, IoModel* iomodel,int analysis_type){{{*/
-Pengrid::Pengrid(int id, int index, IoModel* iomodel, int in_analysis_type){ //i is the element index
+Pengrid::Pengrid(int id, int index, IoModel* iomodel, int in_analysis_type){ //i is the element index/*{{{*/
 
 	int pengrid_node_id;
@@ -74,6 +72,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::~Pengrid(){{{*/
-Pengrid::~Pengrid(){
+Pengrid::~Pengrid(){/*{{{*/
 	delete hnode;
 	delete helement;
@@ -84,11 +81,9 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Pengrid::Echo {{{*/
-void Pengrid::Echo(void){
+void Pengrid::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION Pengrid::DeepEcho{{{*/
-void Pengrid::DeepEcho(void){
+void Pengrid::DeepEcho(void){/*{{{*/
 
 	_printf_("Pengrid:\n");
@@ -104,15 +99,12 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::Id {{{*/
-int    Pengrid::Id(void){ return id; }
-/*}}}*/
-/*FUNCTION Pengrid::ObjectEnum{{{*/
-int Pengrid::ObjectEnum(void){
+int    Pengrid::Id(void){ return id; }/*{{{*/
+/*}}}*/
+int Pengrid::ObjectEnum(void){/*{{{*/
 
 	return PengridEnum;
 }
 /*}}}*/
-/*FUNCTION Icefront::copy {{{*/
-Object* Pengrid::copy() {
+Object* Pengrid::copy() {/*{{{*/
 
 	Pengrid* pengrid=NULL;
@@ -147,6 +139,5 @@
 
 /*Load virtual functions definitions:*/
-/*FUNCTION Pengrid::Configure {{{*/
-void  Pengrid::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
+void  Pengrid::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
 
 	/*Take care of hooking up all objects for this load, ie links the objects in the hooks to their respective 
@@ -165,11 +156,23 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::SetCurrentConfiguration {{{*/
-void  Pengrid::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
-
-}
-/*}}}*/
-/*FUNCTION Pengrid::CreateKMatrix {{{*/
-void  Pengrid::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){
+void  Pengrid::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+void  Pengrid::ResetHooks(){/*{{{*/
+
+	this->node=NULL;
+	this->element=NULL;
+	this->matpar=NULL;
+	this->parameters=NULL;
+
+	/*Get Element type*/
+	this->hnode->reset();
+	this->helement->reset();
+	this->hmatpar->reset();
+
+}
+/*}}}*/
+void  Pengrid::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
 
 	/*No loads applied, do nothing: */
@@ -178,6 +181,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::CreatePVector {{{*/
-void  Pengrid::CreatePVector(Vector<IssmDouble>* pf){
+void  Pengrid::CreatePVector(Vector<IssmDouble>* pf){/*{{{*/
 
 	ElementVector* pe=NULL;
@@ -201,6 +203,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::GetNodesSidList{{{*/
-void Pengrid::GetNodesSidList(int* sidlist){
+void  Pengrid::GetNodesSidList(int* sidlist){/*{{{*/
 
 	_assert_(sidlist);
@@ -210,6 +211,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::GetNodesLidList{{{*/
-void Pengrid::GetNodesLidList(int* lidlist){
+void  Pengrid::GetNodesLidList(int* lidlist){/*{{{*/
 
 	_assert_(lidlist);
@@ -219,12 +219,10 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::GetNumberOfNodes{{{*/
-int Pengrid::GetNumberOfNodes(void){
+int   Pengrid::GetNumberOfNodes(void){/*{{{*/
 
 	return NUMVERTICES;
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreateMatrix {{{*/
-void  Pengrid::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){
+void  Pengrid::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){/*{{{*/
 
 	/*Retrieve parameters: */
@@ -254,6 +252,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreatePVector {{{*/
-void  Pengrid::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){
+void  Pengrid::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){/*{{{*/
 
 	/*Retrieve parameters: */
@@ -285,17 +282,14 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::InAnalysis{{{*/
-bool Pengrid::InAnalysis(int in_analysis_type){
+bool  Pengrid::InAnalysis(int in_analysis_type){/*{{{*/
 	if (in_analysis_type==this->analysis_type)return true;
 	else return false;
 }
 /*}}}*/
-/*FUNCTION Pengrid::IsPenalty{{{*/
-bool Pengrid::IsPenalty(void){
+bool  Pengrid::IsPenalty(void){/*{{{*/
 	return true;
 }
 /*}}}*/
-/*FUNCTION Pengrid::SetwiseNodeConnectivity{{{*/
-void Pengrid::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){
+void  Pengrid::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){/*{{{*/
 
 	/*Output */
@@ -349,31 +343,25 @@
 
 /*Update virtual functions definitions:*/
-/*FUNCTION Pengrid::InputUpdateFromVector(IssmDouble* vector, int name, int type) {{{*/
-void  Pengrid::InputUpdateFromVector(IssmDouble* vector, int name, int type){
+void  Pengrid::InputUpdateFromVector(IssmDouble* vector, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Pengrid::InputUpdateFromMatrixDakota(IssmDouble* vector, int nrows, int ncols, int name, int type) {{{*/
-void  Pengrid::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols, int name, int type){
+void  Pengrid::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Pengrid::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type) {{{*/
-void  Pengrid::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){
+void  Pengrid::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Pengrid::InputUpdateFromConstant(IssmDouble constant, int name) {{{*/
-void  Pengrid::InputUpdateFromConstant(IssmDouble constant, int name){
+void  Pengrid::InputUpdateFromConstant(IssmDouble constant, int name){/*{{{*/
 	/*Nothing*/
 }
 /*}}}*/
-/*FUNCTION Pengrid::InputUpdateFromConstant(int constant, int name) {{{*/
-void  Pengrid::InputUpdateFromConstant(int constant, int name){
+void  Pengrid::InputUpdateFromConstant(int constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Pengrid::InputUpdateFromConstant(bool constant, int name) {{{*/
-void  Pengrid::InputUpdateFromConstant(bool constant, int name){
+void  Pengrid::InputUpdateFromConstant(bool constant, int name){/*{{{*/
 
 	switch(name){
@@ -388,6 +376,5 @@
 
 /*Pengrid management:*/
-/*FUNCTION Pengrid::ConstraintActivate {{{*/
-void  Pengrid::ConstraintActivate(int* punstable){
+void  Pengrid::ConstraintActivate(int* punstable){/*{{{*/
 
 	int analysis_type;
@@ -417,6 +404,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::ConstraintActivateThermal {{{*/
-void  Pengrid::ConstraintActivateThermal(int* punstable){
+void  Pengrid::ConstraintActivateThermal(int* punstable){/*{{{*/
 
 	//   The penalty is stable if it doesn't change during to successive iterations.   
@@ -481,6 +467,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreateKMatrixMelting {{{*/
-ElementMatrix* Pengrid::PenaltyCreateKMatrixMelting(IssmDouble kmax){
+ElementMatrix* Pengrid::PenaltyCreateKMatrixMelting(IssmDouble kmax){/*{{{*/
 
 	IssmDouble pressure,temperature,t_pmp;
@@ -510,6 +495,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreateKMatrixThermal {{{*/
-ElementMatrix* Pengrid::PenaltyCreateKMatrixThermal(IssmDouble kmax){
+ElementMatrix* Pengrid::PenaltyCreateKMatrixThermal(IssmDouble kmax){/*{{{*/
 
 	IssmDouble    penalty_factor;
@@ -528,6 +512,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreatePVectorMelting {{{*/
-ElementVector* Pengrid::PenaltyCreatePVectorMelting(IssmDouble kmax){
+ElementVector* Pengrid::PenaltyCreatePVectorMelting(IssmDouble kmax){/*{{{*/
 
 	IssmDouble pressure;
@@ -570,6 +553,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreatePVectorThermal {{{*/
-ElementVector* Pengrid::PenaltyCreatePVectorThermal(IssmDouble kmax){
+ElementVector* Pengrid::PenaltyCreatePVectorThermal(IssmDouble kmax){/*{{{*/
 
 	IssmDouble pressure;
@@ -596,6 +578,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::ConstraintActivateHydrologyDCInefficient{{{*/
-void  Pengrid::ConstraintActivateHydrologyDCInefficient(int* punstable){
+void  Pengrid::ConstraintActivateHydrologyDCInefficient(int* punstable){/*{{{*/
 
 	//   The penalty is stable if it doesn't change during two consecutive iterations.   
@@ -657,6 +638,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreateKMatrixHydrologyDCInefficient {{{*/
-ElementMatrix* Pengrid::PenaltyCreateKMatrixHydrologyDCInefficient(IssmDouble kmax){
+ElementMatrix* Pengrid::PenaltyCreateKMatrixHydrologyDCInefficient(IssmDouble kmax){/*{{{*/
 	IssmDouble    penalty_factor;
 
@@ -674,6 +654,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::PenaltyCreatePVectorHydrologyDCInefficient {{{*/
-ElementVector* Pengrid::PenaltyCreatePVectorHydrologyDCInefficient(IssmDouble kmax){
+ElementVector* Pengrid::PenaltyCreatePVectorHydrologyDCInefficient(IssmDouble kmax){/*{{{*/
 
 	IssmDouble h_max;
@@ -699,6 +678,5 @@
 }
 /*}}}*/
-/*FUNCTION Pengrid::CreatePVectorHydrologyDCInefficient {{{*/
-ElementVector* Pengrid::CreatePVectorHydrologyDCInefficient(void){
+ElementVector* Pengrid::CreatePVectorHydrologyDCInefficient(void){/*{{{*/
 
 	IssmDouble moulin_load,dt;
@@ -716,6 +694,5 @@
  }
 /*}}}*/
-/*FUNCTION Pengrid::ResetConstraint {{{*/
-void  Pengrid::ResetConstraint(void){
+void  Pengrid::ResetConstraint(void){/*{{{*/
 	active         = 0;
 	zigzag_counter = 0;
Index: issm/trunk/src/c/classes/Loads/Pengrid.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Pengrid.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Pengrid.h	(revision 18301)
@@ -68,4 +68,5 @@
 		void  Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
 		void  SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
+		void  ResetHooks();
 		void  CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs);
 		void  CreatePVector(Vector<IssmDouble>* pf);
Index: issm/trunk/src/c/classes/Loads/Penpair.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Penpair.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Penpair.cpp	(revision 18301)
@@ -19,6 +19,5 @@
 
 /*Penpair constructors and destructor*/
-/*FUNCTION Penpair::constructor {{{*/
-Penpair::Penpair(){
+Penpair::Penpair(){/*{{{*/
 
 	this->hnodes=NULL;
@@ -28,6 +27,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::creation {{{*/
-Penpair::Penpair(int penpair_id, int* penpair_node_ids,int in_analysis_type){
+Penpair::Penpair(int penpair_id, int* penpair_node_ids,int in_analysis_type){/*{{{*/
 
 	this->id=penpair_id;
@@ -40,6 +38,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::destructor {{{*/
-Penpair::~Penpair(){
+Penpair::~Penpair(){/*{{{*/
 	delete hnodes;
 	return;
@@ -48,6 +45,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Penpair::Echo {{{*/
-void Penpair::Echo(void){
+void Penpair::Echo(void){/*{{{*/
 
 	_printf_("Penpair:\n");
@@ -59,6 +55,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::DeepEcho {{{*/
-void Penpair::DeepEcho(void){
+void Penpair::DeepEcho(void){/*{{{*/
 
 	_printf_("Penpair:\n");
@@ -70,15 +65,12 @@
 }		
 /*}}}*/
-/*FUNCTION Penpair::Id {{{*/
-int    Penpair::Id(void){ return id; }
-/*}}}*/
-/*FUNCTION Penpair::ObjectEnum{{{*/
-int Penpair::ObjectEnum(void){
+int  Penpair::Id(void){ return id; }/*{{{*/
+/*}}}*/
+int  Penpair::ObjectEnum(void){/*{{{*/
 
 	return PenpairEnum;
 }
 /*}}}*/
-/*FUNCTION Penpair::copy {{{*/
-Object* Penpair::copy() {
+Object* Penpair::copy() {/*{{{*/
 
 	Penpair* penpair=NULL;
@@ -103,6 +95,5 @@
 
 /*Load virtual functions definitions:*/
-/*FUNCTION Penpair::Configure {{{*/
-void  Penpair::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
+void  Penpair::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
 
 	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
@@ -118,11 +109,19 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::SetCurrentConfiguration {{{*/
-void  Penpair::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
-
-}
-/*}}}*/
-/*FUNCTION Penpair::CreateKMatrix {{{*/
-void  Penpair::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){
+void  Penpair::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+void  Penpair::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->parameters=NULL;
+
+	/*Get Element type*/
+	this->hnodes->reset();
+
+}
+/*}}}*/
+void  Penpair::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
 	/*If you code this piece, don't forget that a penalty will be inactive if it is dealing with clone nodes*/
 	/*No loads applied, do nothing: */
@@ -131,6 +130,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::CreatePVector {{{*/
-void  Penpair::CreatePVector(Vector<IssmDouble>* pf){
+void  Penpair::CreatePVector(Vector<IssmDouble>* pf){/*{{{*/
 
 	/*No loads applied, do nothing: */
@@ -139,11 +137,9 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::CreateJacobianMatrix{{{*/
-void  Penpair::CreateJacobianMatrix(Matrix<IssmDouble>* Jff){
+void  Penpair::CreateJacobianMatrix(Matrix<IssmDouble>* Jff){/*{{{*/
 	this->CreateKMatrix(Jff,NULL);
 }
 /*}}}*/
-/*FUNCTION Penpair::GetNodesSidList{{{*/
-void Penpair::GetNodesSidList(int* sidlist){
+void  Penpair::GetNodesSidList(int* sidlist){/*{{{*/
 
 	_assert_(sidlist);
@@ -153,6 +149,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::GetNodesLidList{{{*/
-void Penpair::GetNodesLidList(int* lidlist){
+void  Penpair::GetNodesLidList(int* lidlist){/*{{{*/
 
 	_assert_(lidlist);
@@ -162,17 +157,14 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::GetNumberOfNodes{{{*/
-int Penpair::GetNumberOfNodes(void){
+int   Penpair::GetNumberOfNodes(void){/*{{{*/
 
 	return NUMVERTICES;
 }
 /*}}}*/
-/*FUNCTION Penpair::IsPenalty{{{*/
-bool Penpair::IsPenalty(void){
+bool  Penpair::IsPenalty(void){/*{{{*/
 	return true;
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrix {{{*/
-void  Penpair::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){
+void  Penpair::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){/*{{{*/
 
 	/*Retrieve parameters: */
@@ -199,23 +191,19 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreatePVector {{{*/
-void  Penpair::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){
+void  Penpair::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){/*{{{*/
 	/*No loads applied, do nothing: */
 	return;
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateJacobianMatrix{{{*/
-void  Penpair::PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax){
+void  Penpair::PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax){/*{{{*/
 	this->PenaltyCreateKMatrix(Jff,NULL,kmax);
 }
 /*}}}*/
-/*FUNCTION Penpair::InAnalysis{{{*/
-bool Penpair::InAnalysis(int in_analysis_type){
+bool  Penpair::InAnalysis(int in_analysis_type){/*{{{*/
 	if (in_analysis_type==this->analysis_type)return true;
 	else return false;
 }
 /*}}}*/
-/*FUNCTION Penpair::SetwiseNodeConnectivity{{{*/
-void Penpair::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){
+void  Penpair::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){/*{{{*/
 
 	/*Output */
@@ -273,21 +261,17 @@
 
 /*Update virtual functions definitions:*/
-/*FUNCTION Penpair::InputUpdateFromConstant(IssmDouble constant, int name) {{{*/
-void  Penpair::InputUpdateFromConstant(IssmDouble constant, int name){
+void  Penpair::InputUpdateFromConstant(IssmDouble constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Penpair::InputUpdateFromConstant(int constant, int name) {{{*/
-void  Penpair::InputUpdateFromConstant(int constant, int name){
+void  Penpair::InputUpdateFromConstant(int constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Penpair::InputUpdateFromConstant(bool constant, int name) {{{*/
-void  Penpair::InputUpdateFromConstant(bool constant, int name){
+void  Penpair::InputUpdateFromConstant(bool constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Penpair::InputUpdateFromVector(IssmDouble* vector, int name, int type) {{{*/
-void  Penpair::InputUpdateFromVector(IssmDouble* vector, int name, int type){
+void  Penpair::InputUpdateFromVector(IssmDouble* vector, int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
@@ -295,6 +279,5 @@
 
 /*Penpair management:*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixStressbalanceHoriz{{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceHoriz(IssmDouble kmax){
+ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceHoriz(IssmDouble kmax){/*{{{*/
 
 	int    approximation0=nodes[0]->GetApproximation();
@@ -329,6 +312,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixStressbalanceSSAHO {{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceSSAHO(IssmDouble kmax){
+ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceSSAHO(IssmDouble kmax){/*{{{*/
 
 	const int numdof=NUMVERTICES*NDOF2;
@@ -356,6 +338,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixStressbalanceFS {{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceFS(IssmDouble kmax){
+ElementMatrix* Penpair::PenaltyCreateKMatrixStressbalanceFS(IssmDouble kmax){/*{{{*/
 
 	const int  numdof=NUMVERTICES*NDOF3;
@@ -388,6 +369,5 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixMasstransport {{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixMasstransport(IssmDouble kmax){
+ElementMatrix* Penpair::PenaltyCreateKMatrixMasstransport(IssmDouble kmax){/*{{{*/
 
 	const int numdof=NUMVERTICES*NDOF1;
